#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "backup") {&backup_text;}

if ($q->param('fct') eq "do_backup") {&do_backup;}
if ($q->param('fct') eq "backup2") {&do_backup2;}
if ($q->param('fct') eq "deleteb") {&deleteb;}
if ($q->param('fct') eq "restore") {&restore;}
if ($q->param('fct') eq "restoref") {&restoref;}
if ($q->param('fct') eq "restoref2") {&restoref2;}



sub backup_text
{

print qq[
<html>

<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>

<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Backup</strong></font><p><strong><font
    face="Verdana" size="1" color="#FF0000">Caution: </font></strong><font face="Verdana"
    size="1">Please do not use the MySQL database that you are using for PowerSeek with third
    party applications. When you restore the PowerSeek backup the data of the<font
    color="#FF0000"><strong> third party applications will be lost!!!</strong></font></font></p>
    <p><font face="Verdana" size="1"><a href="$admin_url/admin47.cgi?fct=do_backup"><strong>Click
    here to make a backup of your PowerSeek Data</strong></a></font></td>
  </tr>
</table>

<hr noshade size="1" color="#EBEBEB">
</body>
</html>
];


}




sub restoref2
{

$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqlp = $allditems[2];

#############

$redirect_html = <<END_OF_REDHTML;

<html>
<head>
<title>PowerSeek</title>
<meta http-equiv="refresh" content="5">
</head>
<body>
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><font face="Verdana" size="1"><img src="$web_url/restore.gif"></font></td>
    <td width="170%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Restoring
    data...<br>
    </strong></font><font face="Verdana" size="1">Please wait... <br>
    <strong>&nbsp;&nbsp; <br>
    Please don't close this window.<br>
    &nbsp;&nbsp; </strong><br>
    If you have tens of thousands of links, then the restore process may take a while.</font></td>
  </tr>
</table>

<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_REDHTML


#############

defined(my $childpid = fork) or die "Cannot fork: $!";

if ($childpid) 
	{
	if ((-e "$data_dir/dbbackup/pid.dat") > 0)
		{
		&restore_completed;
		}
		else
		{
		#print "==> $childpid<br><br>";
		print $redirect_html;
		}
   }
	else #### CHILD PROCESS DOING THE BACKUP
	{
		open STDIN, "</dev/null";
		open STDOUT, ">/dev/null";
		
		if ((-e "$data_dir/dbbackup/pid2.dat") < 1)
		{
			open (PIDF, "> $data_dir/dbbackup/pid2.dat");
			print PIDF "busy";
			close (PIDF);
			
			&drop_tables;
			
			$mysqlp = $mysqlp . " -u $db_username -p" . $db_password . " ";
			
			if ($mysql_hostname ne "")
				{
				$remote_host_crit = "--host=" . $mysql_hostname . " ";
				}
					
			if ($mysql_port ne "")
				{
				$remote_host_crit = $remote_host_crit . "--port=" . $mysql_port . " ";
				}

			$exec_m = "$mysqlp $remote_host_crit $db_name < $data_dir/dbbackup/$db_name.sql";
			
			
			#open(STDOUT, ">$data_dir/dbbackup/tmp1.tmp");
				$stat = system($exec_m);
			#	print STDOUT $stat;
			#close (STDOUT);
			
			
						
						open (TMP, "> $data_dir/dbbackup/tmp.tmp");
							print TMP "$exec_m";
						close (TMP);

			
			#open (PIDF, ">> $data_dir/dbbackup/tmp.tmp"); 
			#	print PIDF "$exec_m\n\n";
			#close (PIDF);
			
			open (PIDF, ">> $data_dir/dbbackup/pid.dat");
				print PIDF "complete";
			close (PIDF);			
		
		exit;
		}
		

	}

}





sub drop_tables
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

### DROP TABLES THAT DOESN'T BELONG TO POWERSEEK - THIS IS SO THAT THE BACKUP CAN BE RESTORED AND THERE 
### ISN'T ANY PROBLEMS IN RESTORING THE BACKUP

@ps_tables = ("links","dirs","reviews","banners","bannergrp","keywlog","balogs","brokenlnks","modified","ppc_admin_banned_ip","ppc_banned_ip","ppc_clickthrough","ppc_impressions","ppc_keywords","ppc_links","ppc_log","ppc_payments","ppc_users");

$sth = $dbh->prepare("SHOW TABLES");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

$tcount = 0;


while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq "ppc_links"){$ppc_links = "true";}
	
	### FOUND TABLE
	$foundm = "false";
	foreach $titem (@ps_tables)
		{
		if ($titem eq $row[0])
			{
			$foundm = "true";
			}
		}
	
	if ($foundm eq "false") { $tables_to_wack[$tcount] = $row[0]; $tcount++;}
	}


if ($tcount > 0)
	{
	foreach $dbitem (@tables_to_wack)
		{
		$sth = $dbh->prepare("DROP TABLE $dbitem");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		}
	}

close (PIDF);

		#open (PIDF, "> $data_dir/dbbackup/tmp.tmp");
		#print PIDF "$tables_to_wack";
		#foreach $item (@tables_to_wack)
		#	{
		#	print PIDF $item . "\n";
		#	}
	   #close (PIDF);


### DROP TABLES

$sth = $dbh->prepare("DELETE FROM balogs"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("DELETE FROM bannergrp"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("DELETE FROM banners"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("DELETE FROM brokenlnks"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("DELETE FROM dirs"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("DELETE FROM keywlog"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("DELETE FROM links"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("DELETE FROM modified"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth = $dbh->prepare("DELETE FROM reviews"); 
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


### LET'S CHECK IF THERE ARE PPC TABLES IN THE BACKUP - IF THERE ARE AND THERE IS NOT IN THE BACKUP THEN LEAVE AS IS

$ldata = &get_file_contents("$data_dir/dbbackup/bsession.dat"); 
@bstats = split (/\n/, $ldata);
foreach $item (@bstats)
	{
	($tbname, $tmpn) = split(/:/, $item);
	
	if ($tbname eq "ppc_links")
		{
		$ppc_links_backed = "true";
		}
	}


if (($ppc_links_backed eq "true") and ($ppc_links_backed eq "true")) ### DELETE PPC DATA
	{
	$sth = $dbh->prepare("DELETE FROM ppc_admin_banned_ip"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sth = $dbh->prepare("DELETE FROM ppc_banned_ip"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sth = $dbh->prepare("DELETE FROM ppc_clickthrough"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sth = $dbh->prepare("DELETE FROM ppc_impressions"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sth = $dbh->prepare("DELETE FROM ppc_keywords"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sth = $dbh->prepare("DELETE FROM ppc_links"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sth = $dbh->prepare("DELETE FROM ppc_log"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sth = $dbh->prepare("DELETE FROM ppc_payments"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

	$sth = $dbh->prepare("DELETE FROM ppc_users"); 
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	}

$sth->finish;
$dbh->disconnect; 

}








sub restore_completed
{
if ((-e "$data_dir/dbbackup/pid.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/pid.dat");
	}

if ((-e "$data_dir/dbbackup/pid2.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/pid2.dat");
	}

if ((-e "$data_dir/dbbackup/verify.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/verify.dat");
	}
	

print <<END_OF_RESTORE;

<html>
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Restore<br>
    </strong></font><font face="Verdana" size="1">Restoration complete. <a
    href="$admin_url/admin43.cgi">Click here to continue.</a></font></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_RESTORE

}




sub restoref
{

if ((-e "$data_dir/dbbackup/tmp.tmp") > 0)
	{ 
	unlink ("$data_dir/dbbackup/tmp.tmp");
	}

if ((-e "$data_dir/dbbackup/pid2.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/pid2.dat");
	}

if ((-e "$data_dir/dbbackup/pid.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/pid.dat");
	}


print <<END_OF_PR;

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="2;URL=$admin_url/admin47.cgi?fct=restoref2">
</head>
<body>
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="100%" valign="top"><strong><font face="Arial" size="4">Preparing to restore
    backup</font><font face="Arial" size="4" color="#000000"><br>
    </font></strong><font face="Verdana" size="1">Please wait... </font></td>
  </tr>
</table>

<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_PR



}


##################################################################################


sub restore
{

### CHECK IF BACKUP IS CONFIGURED
$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqlp = $allditems[2];

if ($mysqlp eq "")
	{

print <<END_OF_CF;

<html>
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Restore<br>
    </strong></font><font face="Verdana" size="1">The PowerSeek restore utility is not
    configured. To configure it, <a href="$admin_url/admin43.cgi?fct=conf">click here.</a></font></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_CF
exit;
	
	}

### CHECK IF mysql EXISTS

$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqldump = $allditems[2];

if ((-e "$mysqldump") < 1)
	{
	acs::problem_popup("$mysqldump does not exist. The mysql program is used to create a backup. Rerun the backup configuration utility.");
	exit;
	}

### CHECK IF BACKUP FILE EXISTS

if ((-e "$data_dir/dbbackup/$db_name.sql") > 0)
	{

$ldata = &get_file_contents("$data_dir/dbbackup/bsession.dat"); 
@bstats = split (/\n/, $ldata);


### GET EXISTING TABLES

@ps_tables = ("links","dirs","reviews","banners","bannergrp","keywlog","balogs","brokenlnks","modified","ppc_admin_banned_ip","ppc_banned_ip","ppc_clickthrough","ppc_impressions","ppc_keywords","ppc_links","ppc_log","ppc_payments","ppc_users");

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SHOW TABLES");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() )
	{
	$tables_to_drop = $tables_to_drop = $row[0];
	
		$tfound = "false";
		foreach $dbtable (@ps_tables)
			{
			if ($dbtable eq $row[0]) { $tfound = "true"; }
			}
		
		if ($tfound eq "true")
			{
			$old_tables = $old_tables . "<li>$row[0]</li><BR>";
			}
			else
			{
			$old_tables = $old_tables . "<li><font color=\"#FF0000\">$row[0] - Not a PowerSeek Table / It will be dropped!!!</font> </li><BR>";
			}
		
	}





	

$sth->finish;
$dbh->disconnect;


$ldata = &get_file_contents("$data_dir/dbbackup/bsession.dat");
@bsession_data = split (/\n/, $ldata);

	foreach $dbtable (@bsession_data)
		{
		($tname,$tnumber) = split (/:/,$dbtable);
		
		$new_tables = $new_tables . "<li>$tname ($tnumber)</li><BR>";
		}


if ($new_tables ne "")
	{
	$restore_text  = qq[
<font color="#FF0000" face="Verdana" size="1"><strong>The following tables with their
    data will be restored: (The number in brackets represents the number of records)</strong></font>	
	];
	}

print <<END_OF_Y;

<html>
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>

<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><strong><font face="Arial" size="4" color="#000000">Restore<br>
    </font><font face="Verdana" size="1">$db_name.sql exists.</strong> This file contains the
    complete backup of your database.</font><p><font color="#000000" face="Verdana" size="1"><strong>Restoring
    a backup will return your database to the state it was when you made a backup of it.</strong></font></p>
    <p><font color="#FF0000" face="Verdana" size="1"><strong>Note that your current data will
    be discarded (all tables in your current database will be dropped) and the old backup
    restored.</strong></font></p>
    <p><font color="#FF0000" face="Verdana" size="1"><strong>The following tables will be
    dropped (all records of the tables below will be discarded):</strong></font></p>
    <blockquote>
      <p><font face="Verdana" size="1">$old_tables</font></p>
    </blockquote>
    <p>$restore_text</p>
    <blockquote>
      <p><font face="Verdana" size="1">$new_tables</font></p>
    </blockquote>
    <div align="center"><center><table border="0" cellpadding="5" cellspacing="1" width="100%"
    style="border: 1px solid rgb(192,192,192)">
      <tr>
        <td width="100%">
        
        <font face="Verdana" size="1"><strong>Would you like to delete all existing data (database tables and their records) with their data and restore the data 
   that you previously backed up?</strong></font><p>
        
        <strong><font face="Verdana" size="4">
        <a href="$admin_url/admin47.cgi?fct=restoref">Yes</a> | <a href="$admin_url/admin43.cgi">No</a></font></strong></td>
      </tr>
    </table>
    </center></div><p><font face="Verdana" size="1">Choosing 'Yes' above will delete all
    contents of your entire database and restore the data in the backup file to your database.</font></p>
    <p><font face="Verdana" size="1"><strong>The following file contains your backup:</strong><br>
    <font color="#FF8000"><strong>$data_dir/dbbackup/$db_name.sql</strong></font></font></td>
  </tr>
</table>

<hr noshade size="1" color="#EBEBEB">
</body>
</html>


END_OF_Y
	
	}
	else
	{

print <<END_OF_N;

<html>
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Restore<br>
    </strong></font><font face="Verdana" size="1">Could not find: </font><br>
    <font color="#FF8000" face="Verdana" size="1"><strong>$data_dir/dbbackup/$db_name.sql</strong></font><p><font
    face="Verdana" size="1">Previous backups would have been made to:</font><br>
    <font color="#FF8000" face="Verdana" size="1"><strong>$data_dir/dbbackup/$db_name.sql</strong></font></p>
    <p><font face="Verdana" size="1">The above file is needed to restore a backup of your
    database.<br>
    &nbsp;&nbsp; <br>
    <a href="$admin_url/admin43.cgi"><strong>Go Back</strong></a></font></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_N
	}


}



sub deleteb
{

unlink ("$data_dir/dbbackup/$db_name.sql");

&do_backup;

}



sub do_backup
{

if ((-e "$data_dir/dbbackup/$db_name.sql") > 0)
	{ 
print <<END_OF_CONFIRM;

<html>
<html>
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><strong><font face="Arial" size="4" color="#000000">Backup<br>
    </font><font face="Verdana" size="1">$db_name.sql exists.</strong> This file is probably
    from a previous backup you made. Should I overwrite this file with the new backup? </font><p><font
    face="Verdana" size="4"><strong><a href="$admin_url/admin47.cgi?fct=deleteb">Yes</a> | <a
    href="$admin_url/admin47.cgi">No</a></strong></font></p>
    <p><font face="Verdana" size="1" color="#FF0000"><strong>Note that this file will be lost
    if you choose 'Yes'</strong></font></p>
    <p><strong><font face="Verdana" size="1">If you choose 'Yes', then your database will be
    backed up to <br>
    <font color="#FF8000">$data_dir/dbbackup/$db_name.sql</font></font></strong></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_CONFIRM
exit;
	}


if ((-e "$data_dir/dbbackup") < 1)
	{ 
	mkdir ("$data_dir/dbbackup", $default_permissions);
	chmod($default_permissions,"$data_dir/dbbackup","$data_dir/dbbackup");
	}

if ((-e "$data_dir/dbbackup/pid.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/pid.dat");
	}


if ((-e "$data_dir/dbbackup/pid2.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/pid2.dat");
	}

if ((-e "$data_dir/dbbackup/verify.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/verify.dat");
	}


print <<END_OF_FI;

<html>
<head>
<title>PowerSeek</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$admin_url/admin47.cgi?fct=backup2">
</head>
<body>
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="100%" valign="top"><strong><font face="Arial" size="4">Preparing to do a backup</font><font
    face="Arial" size="4" color="#000000"><br>
    </font></strong><font face="Verdana" size="1">Please wait... </font></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_FI
}






sub do_backup2
{

$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);

$mysqldump = $allditems[1];

if ($mysqldump eq "")
	{
print <<END_OF_CF;

<html>
<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>
<body>
<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Backup<br>
    </strong></font><font face="Verdana" size="1">The PowerSeek backup utility is not
    configured. To configure it, <a href="$admin_url/admin43.cgi?fct=conf">click here.</a></font></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_CF
exit;
	}


$ldata = &get_file_contents("$data_dir/backup.cfg"); 
@allditems = split (/\n/, $ldata);
$mysqldump = $allditems[1];

if ((-e "$mysqldump") < 1)
	{
	acs::problem_popup("$mysqldump does not exist. The mysqldump program is used to create a backup. Rerun the backup configuration utility.");
	exit;
	}


$redirect_html = <<END_OF_FI;
<html>
<head>
<title>PowerSeek</title>
<meta http-equiv=refresh content=2>
</head>
<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><font face="Verdana" size="1"><img src="$web_url/backup.gif"></font></td>
    <td width="170%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Backing
    up data...<br>
    </strong></font><font face="Verdana" size="1">Please wait... <br>
    <strong>&nbsp;&nbsp; <br>
    Please don't close this window.<br>
    &nbsp;&nbsp; </strong><br>
    If you have tens of thousands of links, then the backup may take a while.</font></td>
  </tr>
</table>

<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_FI


########################

defined(my $childpid = fork) or die "Cannot fork: $!";

if ($childpid) 
	{
	
	if ((-e "$data_dir/dbbackup/pid.dat") > 0)
		{ 
		&backup_completed;
		}
		else
		{
		print $redirect_html; exit;
		}
   }
	else #### IF CHILD PROCESS DO BACKUP
	{
		
		open STDIN, "</dev/null";
		open STDOUT, ">/dev/null";

		if ((-e "$data_dir/dbbackup/pid2.dat") < 1)
		{

		open (PIDF, "> $data_dir/dbbackup/pid2.dat");
		print PIDF "busy";
		close (PIDF);
		
		
		if ($mysql_hostname ne "")
			{
			$remote_host_crit = "--host=" . $mysql_hostname . " ";
			}
		
		if ($mysql_port ne "")
			{
			$remote_host_crit = $remote_host_crit . "--port=" . $mysql_port . " ";
			}
		
		$stat = system("$mysqldump -u $db_username -p$db_password $db_name $remote_host_crit --quick --no-create-info --complete-insert --add-locks > $data_dir/dbbackup/$db_name.sql");

		open (PIDF, "> $data_dir/dbbackup/bcrit.dat");
			print PIDF "$mysqldump -u $db_username -p$db_password $db_name $remote_host_crit --quick --no-create-info --complete-insert --add-locks > $data_dir/dbbackup/$db_name.sql";
		close (PIDF);		
		
		#$result =      `$mysqldump -u $db_username -p$db_password $db_name $remote_host_crit --quick --no-create-info --complete-insert --add-locks --verbose > $data_dir/dbbackup/$db_name.sql`;
		#open (PS, "$mysqldump -u $db_username -p$db_password $db_name $remote_host_crit --quick --no-create-info --complete-insert --add-locks --verbose > $data_dir/dbbackup/$db_name.sql |") or $open_error = $!;
		#while (defined($line=<PS>)){$bverbose = $bverbose . $line;}		
		
		chmod($default_permissions,"$data_dir/dbbackup/$db_name.sql","$data_dir/dbbackup/$db_name.sql");
		
		&check_backup_integrity;
		
		open (PIDF, ">> $data_dir/dbbackup/pid.dat");
			print PIDF "complete!";
		close (PIDF);
		}
		
	exit;
	}
	
########################	



}





sub check_backup_integrity
{

### GET EXISTING RECORD NUMBERS

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

### DIRS

$sth = $dbh->prepare("SELECT COUNT(*) FROM dirs");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$dirs = $row[0];} 

### LINKS

$sth = $dbh->prepare("SELECT COUNT(*) FROM links");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$links = $row[0];} 

### REVIEWS

$sth = $dbh->prepare("SELECT COUNT(*) FROM reviews");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$reviews = $row[0];} 

### BANNERS

$sth = $dbh->prepare("SELECT COUNT(*) FROM banners");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$banners = $row[0];} 

### bannergrp

$sth = $dbh->prepare("SELECT COUNT(*) FROM bannergrp");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$bannergrp = $row[0];} 

### keywlog

$sth = $dbh->prepare("SELECT COUNT(*) FROM keywlog");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$keywlog = $row[0];}

### balogs

$sth = $dbh->prepare("SELECT COUNT(*) FROM balogs");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$balogs = $row[0];}

### brokenlnks

$sth = $dbh->prepare("SELECT COUNT(*) FROM brokenlnks");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$brokenlnks = $row[0];}

$sth = $dbh->prepare("SELECT COUNT(*) FROM modified");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
while ( @row = $sth->fetchrow() ){$modified = $row[0];}




### LETS CHECK IF THE THERE ARE ANY PPC DATA

$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
while ( @row = $sth->fetchrow() )
	{
	if ($row[0] eq "ppc_links") { $ppc_links1 = "True"; }
	}



	if ($ppc_links1 eq "True")
		{
		
		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_admin_banned_ip");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_admin_banned_ip = $row[0];}

		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_banned_ip");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_banned_ip = $row[0];}

		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_clickthrough");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_clickthrough = $row[0];}

		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_impressions");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_impressions = $row[0];}

		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_keywords");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_keywords = $row[0];}
		
		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_links");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_links = $row[0];}
		
		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_log");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_log = $row[0];}	

		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_payments");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_payments = $row[0];}

		$sth = $dbh->prepare("SELECT COUNT(*) FROM ppc_users");
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 
		while ( @row = $sth->fetchrow() ){$ppc_users = $row[0];}		
		}
		
####

$sth->finish;
$dbh->disconnect;

open (STP, "$data_dir/dbbackup/$db_name.sql");
	while (defined($line=<STP>))
		{

		if ($current_tbl eq "dirs"){$dirs_no++;}
		if ($current_tbl eq "links"){$links_no++;}
		if ($current_tbl eq "reviews"){$reviews_no++;}
		if ($current_tbl eq "banners"){$banners_no++;}
		if ($current_tbl eq "bannergrp"){$bannergrp_no++;}
		if ($current_tbl eq "keywlog"){$keywlog_no++;}
		if ($current_tbl eq "balogs"){$balogs_no++;}
		if ($current_tbl eq "brokenlnks"){$brokenlnks_no++;}
		if ($current_tbl eq "modified"){$modified_no++;}

		if ($current_tbl eq "ppc_admin_banned_ip"){$ppc_admin_banned_ip_no++;}
		if ($current_tbl eq "ppc_banned_ip"){$ppc_banned_ip_no++;}
		if ($current_tbl eq "ppc_clickthrough"){$ppc_clickthrough_no++;}
		if ($current_tbl eq "ppc_impressions"){$ppc_impressions_no++;}
		if ($current_tbl eq "ppc_keywords"){$ppc_keywords_no++;}
		if ($current_tbl eq "ppc_links"){$ppc_links_no++;}
		if ($current_tbl eq "ppc_log"){$ppc_log_no++;}
		if ($current_tbl eq "ppc_payments"){$ppc_payments_no++;}
		if ($current_tbl eq "ppc_users"){$ppc_users_no++;}
		
		################

		if ($line =~ /LOCK TABLES dirs WRITE/){$current_tbl = "dirs";}
		if ($line =~ /LOCK TABLES links WRITE/){$current_tbl = "links";}
		if ($line =~ /LOCK TABLES reviews WRITE/){$current_tbl = "reviews";}
		if ($line =~ /LOCK TABLES banners WRITE/){$current_tbl = "banners";}
		if ($line =~ /LOCK TABLES bannergrp WRITE/){$current_tbl = "bannergrp";}
		if ($line =~ /LOCK TABLES keywlog WRITE/){$current_tbl = "keywlog";}
		if ($line =~ /LOCK TABLES balogs WRITE/){$current_tbl = "balogs";}
		if ($line =~ /LOCK TABLES brokenlnks WRITE/){$current_tbl = "brokenlnks";}
		if ($line =~ /LOCK TABLES modified WRITE/){$current_tbl = "modified";}

		if ($line =~ /LOCK TABLES ppc_admin_banned_ip WRITE/){$current_tbl = "ppc_admin_banned_ip";}
		if ($line =~ /LOCK TABLES ppc_banned_ip WRITE/){$current_tbl = "ppc_banned_ip";}
		if ($line =~ /LOCK TABLES ppc_clickthrough WRITE/){$current_tbl = "ppc_clickthrough";}
		if ($line =~ /LOCK TABLES ppc_impressions WRITE/){$current_tbl = "ppc_impressions";}
		if ($line =~ /LOCK TABLES ppc_keywords WRITE/){$current_tbl = "ppc_keywords";}
		if ($line =~ /LOCK TABLES ppc_links WRITE/){$current_tbl = "ppc_links";}
		if ($line =~ /LOCK TABLES ppc_log WRITE/){$current_tbl = "ppc_log";}
		if ($line =~ /LOCK TABLES ppc_payments WRITE/){$current_tbl = "ppc_payments";}
		if ($line =~ /LOCK TABLES ppc_users WRITE/){$current_tbl = "ppc_users";}

		if ($line =~ /UNLOCK TABLES/){$current_tbl = "";}			
		}
close (STP);

$dirs_no = ($dirs_no - 1);
$links_no = ($links_no - 1);
$reviews_no = ($reviews_no - 1);
$banners_no = ($banners_no - 1);
$bannergrp_no = ($bannergrp_no - 1);
$keywlog_no = ($keywlog_no - 1);
$balogs_no = ($balogs_no - 1);
$brokenlnks_no = ($brokenlnks_no - 1);
$modified_no = ($modified_no - 1);



if ($dirs_no == $dirs) { $dirs_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$dirs_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>"; $bfail = "true";}
if ($links_no == $links) { $links_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$links_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
if ($reviews_no == $reviews) { $reviews_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$reviews_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true"; }
if ($banners_no == $banners) { $banners_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$banners_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true"; }
if ($bannergrp_no == $bannergrp) { $bannergrp_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$bannergrp_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true"; }
#if ($keywlog_no == $keywlog) { $keywlog_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$keywlog_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
if ($balogs_no == $balogs) { $balogs_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$balogs_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
if ($brokenlnks_no == $brokenlnks) { $brokenlnks_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$brokenlnks_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
if ($modified_no == $modified) { $modified_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$modified_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}


$ppc_admin_banned_ip_no = ($ppc_admin_banned_ip_no - 1);
$ppc_banned_ip_no = ($ppc_banned_ip_no - 1);
$ppc_clickthrough_no = ($ppc_clickthrough_no - 1);
$ppc_impressions_no = ($ppc_impressions_no - 1);
$ppc_keywords_no = ($ppc_keywords_no - 1);
$ppc_links_no = ($ppc_links_no - 1);
$ppc_log_no = ($ppc_log_no - 1);
$ppc_payments_no = ($ppc_payments_no - 1);
$ppc_users_no = ($ppc_users_no - 1);



if ($ppc_links1 eq "True")
	{
	if ($ppc_admin_banned_ip_no == $ppc_admin_banned_ip) { $ppc_admin_banned_ip_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_admin_banned_ip_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>"; $bfail = "true";}
	if ($ppc_banned_ip_no == $ppc_banned_ip) { $ppc_banned_ip_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_banned_ip_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
	if ($ppc_clickthrough_no == $ppc_clickthrough) { $ppc_clickthrough_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_clickthrough_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true"; }
	#if ($ppc_impressions_no == $ppc_impressions) { $ppc_impressions_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_impressions_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true"; }
	if ($ppc_keywords_no == $ppc_keywords) { $ppc_keywords_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_keywords_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true"; }
	if ($ppc_links_no == $ppc_links) { $ppc_links_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_links_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
	if ($ppc_log_no == $ppc_log) { $ppc_log_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_log_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
	if ($ppc_payments_no == $ppc_payments) { $ppc_payments_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_payments_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
	if ($ppc_users_no == $ppc_users) { $ppc_users_res = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\">OK</font>"; } else {$ppc_users_res = "<font face=\"Verdana\" size=\"1\" color=\"#FF0000\">FAILED</font>";  $bfail = "true";}
	}


if ($bfail ne "true")
	{
	$bresult = "<font face=\"Verdana\" size=\"1\" color=\"#0000FF\"><strong>Backup Completed Successfully!</strong></font>";
	}
	else
	{
$bresult = <<END_OF_BR;
<p><font color="#FF0000" face="Verdana" size="1"><strong>Backup Failed</strong></font></p>
<p><font face="Verdana" size="1">Backups will fail in the following situations:</font>
<ul>
  <li><font face="Verdana" size="1">The full server path to the mysqldump program is not
    correct.</font></li>
  <li><font face="Verdana" size="1">Your host/server does not allow Perl to execute system
    commands.</font></li>
  <li><font face="Verdana" size="1">The mysqldump program file does not have the correct
    permissions so that the backup utility can execute it.</font></li>
  <li><font face="Verdana" size="1">The wrong mysqldump program is used. This can occur if
    there is more than 2 versions of mysql installed on your host.</font></li>
</ul>
<p><font face="Verdana" size="1">&nbsp;</font></p>
END_OF_BR

	if ((-e "$data_dir/dbbackup/$db_name.sql") > 0)
		{ 
		unlink ("$data_dir/dbbackup/$db_name.sql");
		}
	}

########
if ($ppc_links1 eq "True")
	{
$ppc_det = qq[	

  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_admin_banned_ip</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_admin_banned_ip</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_admin_banned_ip_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$ppc_banned_ip_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_banned_ip</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_banned_ip</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_banned_ip_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$ppc_banned_ip_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_clickthrough</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_clickthrough</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_clickthrough_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$ppc_clickthrough_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_impressions</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_impressions</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_impressions_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$ppc_impressions_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_keywords</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_keywords</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_keywords_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$dirs_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_links</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_links</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_links_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$ppc_links_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_log</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_log</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_log_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$ppc_log_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_payments</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_payments</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_payments_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$ppc_payments_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">ppc_users</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_users</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$ppc_users_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$ppc_users_res</td>
  </tr>
];
	}



$verify_res = <<END_OF_VRS;

<p><strong><font face="Verdana" size="1">Backup File: <br>
<font color="#FF8000">$data_dir/dbbackup/$db_name.sql</font></font></strong></p>
<p><font face="Verdana" size="1"><strong>The backup file has been verified. Below is the
results:</strong></font></p>
<div align="center"><center>
<table border="0" cellspacing="1" width="100%" cellpadding="6" style="border: 1px solid">
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1"><strong>Table Name</strong></font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1"><strong>Real Table Records</strong></font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1"><strong>Backed-up Table
    Records</strong></font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1"><strong>Backup Status</strong></font></td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">links</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$links</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$links_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$links_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">dirs</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$dirs</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$dirs_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$dirs_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">reviews</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$reviews</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$reviews_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$reviews_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">banners</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$banners</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$banners_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$banners_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">bannergrp</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$bannergrp</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$bannergrp_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$bannergrp_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">keywlog</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$keywlog</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$keywlog_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$keywlog_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">balogs</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$balogs</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$balogs_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$balogs_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">brokenlnks</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$brokenlnks</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$brokenlnks_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$brokenlnks_res</td>
  </tr>
  <tr>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">modified</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$modified</font></td>
    <td width="25%" bgcolor="#F7F7F7"><font face="Verdana" size="1">$modified_no</font></td>
    <td width="25%" bgcolor="#F7F7F7">$modified_res</td>
  </tr>
 
  
  $ppc_det
</table>
</center></div>
<p>$bresult</p>

END_OF_VRS

open (WFI, "> $data_dir/dbbackup/verify.dat");
	print WFI "$verify_res";
close (WFI);
chmod($default_permissions,"$data_dir/dbbackup/verify.dat","$data_dir/dbbackup/verify.dat");

##########

open (BSTAT, "> $data_dir/dbbackup/bsession.dat");
  print BSTAT "links:$links\n";
  print BSTAT "dirs:$dirs\n";
  print BSTAT "reviews:$reviews\n";
  print BSTAT "banners:$banners\n";
  print BSTAT "bannergrp:$bannergrp\n";
  print BSTAT "keywlog:$keywlog\n";
  print BSTAT "balogs:$balogs\n";
  print BSTAT "brokenlnks:$brokenlnks\n";
  print BSTAT "modified:$modified\n";
  

 if ($ppc_links1 eq "True")
 	{
  	print BSTAT "ppc_admin_banned_ip:$ppc_admin_banned_ip_no\n";
  	print BSTAT "ppc_banned_ip:$ppc_banned_ip_no\n";
  	print BSTAT "ppc_clickthrough:$ppc_clickthrough_no\n";
  	print BSTAT "ppc_impressions:$ppc_impressions_no\n";
  	print BSTAT "ppc_keywords:$ppc_keywords_no\n";
  	print BSTAT "ppc_links:$ppc_links_no\n";
  	print BSTAT "ppc_log:$ppc_log_no\n";
  	print BSTAT "ppc_payments:$ppc_payments_no\n";
  	print BSTAT "ppc_users:$ppc_users_no\n";
  	}
  
close (BSTAT);
chmod($default_permissions,"$data_dir/dbbackup/bsession.dat","$data_dir/dbbackup/bsession.dat");



}




sub backup_completed
{

if ((-e "$data_dir/dbbackup/pid.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/pid.dat");
	}


if ((-e "$data_dir/dbbackup/pid2.dat") > 0)
	{ 
	unlink ("$data_dir/dbbackup/pid2.dat");
	}


$backup_details = &get_file_contents("$data_dir/dbbackup/verify.dat"); 

if ($backup_details eq "")
	{
$backup_details = <<END_OF_NOTH;

<p><font face="Verdana" size="1"><strong><font color="#FF0000">An Error Occurred while
trying to backup your database. <br>
</font>Did not recieve any verification information from the thread that actually does the
backup.<br><font color="#0000FF">Please try again</font></strong></font></p>

END_OF_NOTH
	}

print <<END_OF_BK;

<html>

<head>
<title>PowerSeek</title>
<style type="text/css">
A {COLOR: #0000FF}
A:visited {COLOR: #0000FF}
A:active {COLOR: #000000}
A:hover {COLOR: #000000}
</style>
</head>

<body>

<table border="0" cellpadding="5" cellspacing="0" width="100%">
  <tr>
    <td width="1%" valign="top"><img src="$web_url/templm.gif"></td>
    <td width="99%" valign="top"><strong><font face="Arial" size="4" color="#000000">Backup
    Completed<br>
    </font></strong><font face="Verdana" size="1">Refer to the <strong><a
    href="http://www.focalmedia.net/pseekmanual/pseek9.html#9_6" target="_blank">PowerSeek
    Manual for information on doing a backup</a> </strong>of all your data, templates and
    settings.</font><p><font face="Verdana" size="1">$backup_details</font></p>
    <p><a href="$admin_url/admin43.cgi"><font face="Verdana" size="1"><strong>Click here to
    continue</strong></font></a></td>
  </tr>
</table>

<hr noshade size="1" color="#EBEBEB">
</body>
</html>


END_OF_BK


}




sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

